VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DrawingTool"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'////////////////////////////////////
'/
'/  Classe d'outils de dessin
'/
'/
'/  A LEROY le 13.06.2000
'/
'////////////////////////////////////


'dclaration des enum
Public Enum ModeDegrade
    
    LEFT_TO_RIGHT = 0
    RIGHT_TO_LEFT = 1
    TOP_TO_BOTTOM = 2
    BOTTOM_TO_TOP = 3
    
End Enum

Public Enum DegradeDirection
    
    VERTICAL = 0
    HORIZONTAL = 1
    
End Enum

'Fonction permettant de remplir un objet avec un dgrad
Sub Fill_degrade(Obj As Object, Mode As ModeDegrade, StartColor As Long, EndColor As Long)
'   ++++++++++++
    
    'dclaration des variables
    Dim i As Integer
    Dim PosStart As Integer
    Dim PosEnd As Integer
    Dim sens As Integer
    Dim Direction As DegradeDirection
    Dim StepRed As Single
    Dim StepGreen As Single
    Dim StepBlue As Single
    Dim iRed As Single
    Dim iGreen As Single
    Dim iBlue As Single
    
    
    Obj.ScaleMode = 3
    
    Select Case Mode
        
        Case LEFT_TO_RIGHT
            Direction = HORIZONTAL
            PosStart = 0
            PosEnd = Obj.ScaleWidth
            sens = 1
            
        Case RIGHT_TO_LEFT
            Direction = HORIZONTAL
            PosStart = Obj.ScaleWidth
            PosEnd = 0
            sens = -1
            
        Case TOP_TO_BOTTOM
            Direction = VERTICAL
            PosStart = 0
            PosEnd = Obj.ScaleHeight
            sens = 1
            
        Case BOTTOM_TO_TOP
            Direction = VERTICAL
            PosStart = Obj.ScaleHeight
            PosEnd = 0
            sens = -1
            
    End Select
    
    iRed = RedFromRGB(StartColor)
    iGreen = GreenFromRGB(StartColor)
    iBlue = BlueFromRGB(StartColor)
    
    Select Case Direction
            
            Case HORIZONTAL
                StepRed = (RedFromRGB(EndColor) - iRed) / Obj.ScaleWidth
                StepGreen = (GreenFromRGB(EndColor) - iGreen) / Obj.ScaleWidth
                StepBlue = (BlueFromRGB(EndColor) - iBlue) / Obj.ScaleWidth
            Case VERTICAL
                StepRed = (RedFromRGB(EndColor) - iRed) / Obj.ScaleHeight
                StepGreen = (GreenFromRGB(EndColor) - iGreen) / Obj.ScaleHeight
                StepBlue = (BlueFromRGB(EndColor) - iBlue) / Obj.ScaleHeight
            
    End Select
    
    For i = PosStart To PosEnd Step sens
        
        
        Select Case Direction
            
            Case HORIZONTAL
         
                Obj.Line (i, 0)-(i, Obj.ScaleHeight), rgb(CInt(iRed), CInt(iGreen), CInt(iBlue))
        
            Case VERTICAL
            
                Obj.Line (0, i)-(Obj.ScaleWidth, i), rgb(CInt(iRed), CInt(iGreen), CInt(iBlue))
                
        End Select
        
        iRed = iRed + StepRed
        iGreen = iGreen + StepGreen
        iBlue = iBlue + StepBlue
        
    Next i
       Obj.ScaleMode = 1
End Sub

'-----------------------------------------------------------
' SUB: DrawBackGround
'
' Draws the 'blue wash' screen and prints the 'shadowed'
' app setup title
'-----------------------------------------------------------

Public Sub DrawBackGround(Obj As Object)

    Const intBLUESTART% = 255
    Const intBLUEEND% = 0
    Const intBANDHEIGHT% = 2
    Const intSHADOWSTART% = 8
    Const intSHADOWCOLOR% = 0
    Const intTEXTSTART% = 4
    Const intTEXTCOLOR% = 15
    Const intRed% = 1
    Const intGreen% = 2
    Const intBlue% = 4
    Const intBackRed% = 8
    Const intBackGreen% = 16
    Const intBackBlue% = 32
    Dim sngBlueCur As Single
    Dim sngBlueStep As Single
    Dim intFormHeight As Integer
    Dim intFormWidth As Integer
    Dim intY As Integer
    Dim iColor As Integer
    Dim iRed As Single, iBlue As Single, iGreen As Single
    
    Obj.ScaleMode = 3
    
    '
    'Get system values for height and width
    '
    intFormHeight = Obj.ScaleHeight
    intFormWidth = Obj.ScaleWidth

    iColor = intBlue
    
    'Calculate step size and blue start value
    '
    sngBlueStep = intBANDHEIGHT * (intBLUEEND - intBLUESTART) / intFormHeight
    sngBlueCur = intBLUESTART

    '
    'Paint blue screen
    '
    For intY = 0 To intFormHeight Step intBANDHEIGHT
        If iColor And intBlue Then iBlue = sngBlueCur
        If iColor And intRed Then iRed = sngBlueCur
        If iColor And intGreen Then iGreen = sngBlueCur
        If iColor And intBackBlue Then iBlue = 255 - sngBlueCur
        If iColor And intBackRed Then iRed = 255 - sngBlueCur
        If iColor And intBackGreen Then iGreen = 255 - sngBlueCur
        Obj.Line (-1, intY - 1)-(intFormWidth, intY + intBANDHEIGHT), rgb(iRed, iGreen, iBlue), BF
        sngBlueCur = sngBlueCur + sngBlueStep
    Next intY
    
End Sub

'Fonction permettant de rcuprer la composant rouge d'un RGB
Public Function RedFromRGB(ByVal rgb As Long) As Integer
   RedFromRGB = &HFF& And rgb
End Function

'Fonction permettant de rcuprer la composant verte d'un RGB
Public Function GreenFromRGB(ByVal rgb As Long) As Integer
   GreenFromRGB = (&HFF00& And rgb) \ 256
End Function

'Fonction permettant de rcuprer la composant bleue d'un RGB
Public Function BlueFromRGB(ByVal rgb As Long) As Integer
   BlueFromRGB = (&HFF0000 And rgb) \ 65536
End Function

